#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <arpa/inet.h>

#define	MAXLINE	128	// maximum bytes to receive and send at once

// External functions
extern int swap_wait(unsigned short port);
extern int swap_read(int sd, unsigned char buf[]);
extern void swap_close(int sd);

int main(int argc, char *argv[])
{
	unsigned short server_port;
	unsigned int server_address;
	unsigned char message[MAXLINE];
	unsigned char buf[MAXLINE];
	int sd, n, out;

	if (argc < 2) {
		fprintf(stderr, "Usage: %s port\n", argv[0]);
		exit(1);
	}

	// set values for server address and port number
	server_port = htons(atoi(argv[1]));

	// connect to the port allocated to the swap server
	sd = swap_wait(server_port);
	if (sd < 0) {
		fprintf(stderr, "swap_open error\n");
		exit(0);
	}

	//Students to code the following:
	printf("Tolga Olcay T00666715\n");
	
	//read in the first message as the new name of the file
	unsigned char name [MAXLINE];
	swap_read(sd, name);
	int len = strlen(name);
	name[len-4] = '\0';
	strcat(name, "_copy.txt");
	//open output file for writing
	out = open(name, O_WRONLY | O_TRUNC | O_CREAT, S_IRUSR | S_IWUSR);
	if (out < 0) {
		printf("Cannot create the file %s\n", name);
		exit(1);
	}
	
	
	
	//begin-loop
		//get the file data from the client until end-of-file
	//end-loop
	swap_read(sd, message);
	int mlen = strlen(message);
	int wout = write(out, message, mlen);
	
	
	// close the connection to the swap servfer
	swap_close(sd);
	
	//close connection to output file
	close(out);
}
